﻿define([],
        function () {

            function DeviceAdapter() {
                
                function isOnline() {
                    return true;
                }

                function platform() {
                    var PLATFORM_WEB = 1;
                    var PLATFORM_ANDROID = 2;
                    var PLATFORM_IOS = 3;

                    var val = PLATFORM_WEB;
                    if (window.device && window.device.platform && window.device.platform.toLowerCase() == 'android') {
                        val = PLATFORM_ANDROID;
                    }
                    if (window.device && window.device.platform && window.device.platform.toLowerCase() == 'ios') {
                        val = PLATFORM_IOS;
                    }

                    return val;
                }

                function asString() {
                    if (!window.device) return "";

                    return 'Device Model: ' + window.device.model + '\n' +
                        'Device Cordova: ' + window.device.cordova + '\n' +
                        'Device Platform: ' + window.device.platform + '\n' +
                        'Device UUID: ' + window.device.uuid + '\n' +
                        'Device Version: ' + window.device.version;
                }

                this.isOnline = isOnline;
                this.asString = asString;
                this.platform = platform;
            }

            return new DeviceAdapter();
        }
);

