﻿define([],
        function () {

            var LocalStorageAdapter = function () {
                this.set = function (key, value) {
                    if (value === null) {
                        window.localStorage.removeItem(key);
                    } else {
                        window.localStorage.setItem(key, JSON.stringify(value));
                    }
                }
                this.get = function (key) {
                    var val = window.localStorage.getItem(key);
                    if (val === null) return null;
                    return JSON.parse(val);
                };
                this.remove = function (key) {
                    window.localStorage.removeItem(key);
                };
            }

            return new LocalStorageAdapter();
        }
);

