﻿define(['jquery', 'libGlobalize', 'preferences','culture.en', 'culture.fa'],
        function ($, Globalize, preferences) {

            var faCulture = Globalize.culture('fa-IR');
            var defaultCulture = Globalize.culture('fa-IR');

            // set default fallback
            Globalize.cultures["default"] = defaultCulture;

            // add helper functions
            Globalize.localizeBase = function (base) {
                return function (key) {
                    return Globalize.localize(base + "." + key);
                }
            }

            Globalize.setCulture = function (c) {
                var info = Globalize.culture(c);
                if ($.timeago){
                    $.timeago.settings.strings = info.plugins.timeago;
                }

                return info;
            }

            // lang init here
            var lang = preferences.language();
            if (!lang) lang = defaultCulture.name;
            Globalize.setCulture(lang);

            return Globalize;
        }
);

