define(["libGlobalize", 'culture.en.messages', 'culture.en.timeago'],

    function (Globalize,messages,pluginTimeago) {

        Globalize.addCultureInfo("en-GB", "default", {
            name: "en-GB",
            englishName: "English (United Kingdom)",
            nativeName: "English (United Kingdom)",
            numberFormat: {
                currency: {
                    pattern: ["-$ n", "$ n"],
                    symbol: "T"
                }
            },
            calendars: {
                standard: {
                    firstDay: 1,
                    patterns: {
                        d: "dd/MM/yyyy",
                        D: "dd MMMM yyyy",
                        t: "HH:mm",
                        T: "HH:mm:ss",
                        f: "dd MMMM yyyy HH:mm",
                        F: "dd MMMM yyyy HH:mm:ss",
                        M: "dd MMMM",
                        Y: "MMMM yyyy"
                    }
                }
            },
            plugins: {
                timeago: pluginTimeago
            },
            messages: messages
        });

        return Globalize;

    }

);

