﻿define(["jquery",'libIScroll','uiGlobal'],
function ($, IScroll, uiGlobal) {

    function NativeScrolling(elm, opt) {
        var el = $(elm);
        var options = opt;

        this.destroy = function () {

        };
        this.refresh = function () {
            if (el) {
                el.toggleClass("scrollable", true);
            }
        };

        this.scrollTop = function (val) {
            if (el) {
                if (typeof val === 'undefined') return el.scrollTop();
                el.scrollTop(val);
            }

            return this;
        }
                
        this.on = function (e, fn) {
            if (el) {
                el.on(e, fn);
            }

            return this;
        }

        this.off = function (e, fn) {
            if (el) {
                el.off(e, fn);
            }

            return this;
        }

        this.create = function () {
            if (el) {
                el.toggleClass("scrollable", true);
            }
        }

        this.create();

        
        //$(elm).css({
        //    "overflow": "hidden",
        //    "overflowY": "scroll",
        //    "-webkit-overflow-scrolling": "touch"
        //});
    }

    function IScrollScrolling(elm, opt) {
        var inst = null;
        var el = elm;
        var options = opt;

        this.destroy = function () {
            if (!inst) return;
            inst.off("scroll");
            inst.destroy();
            inst = null;
        }
        
        this.refresh = function () {
            if (!inst) return this;

            this.destroy();
            this.create();
           
            return this;
        }

        this.on = function (e, fn) {
            if (inst) {
                inst.on(e, fn);
            }

            return this;
        }

        this.off = function (e, fn) {
            if (inst) {
                inst.off(e, fn);
            }

            return this;
        }

        this.scrollTop = function (val) {
            if (inst) {
                if (typeof val === 'undefined') return 0;
                inst.scrollTo(0, val);
            }

            return this;
        }

        this.create = function () {
            inst = new IScroll(el, $.extend({}, {
                    //  bounce: false,
                    //   momentum: true,
                   // disableMouse: true,
                  //  disablePointer: true,
                    scrollbars: false,
                    // bindToWrapper:true,
                    probeType: 1
                    //onBeforeScrollStart: function (e) {
                    //    var target = e.target;
                    //    while (target.nodeType != 1) target = target.parentNode;
                    //    if (target.tagName != 'SELECT' && target.tagName != 'INPUT' && target.tagName != 'TEXTAREA') {
                    //        e.preventDefault();
                    //    }
                    //}
            }, options));

            //inst.on("scroll", function () {
            //});
        }

        this.create();
    }

    function Scroll(elm,opt) {
        var inst, el, options;
     
        el = elm;
        options = opt;

        this.destroy = function () {
            if (!inst) return;
            inst.destroy();
            inst = null;
            //if (el) {
            //    $(el).removeData("scroller");
            //}
        }

        this.refresh = function () {
            if (inst) {
                inst.refresh();
            }

            return this;
        }

        this.get = function () {
            return inst;
        }

        this.scrollTop = function (val) {
            if (inst) {
                inst.scrollTop(val);
            }
        }

        this.on = function (e, fn) {
            if (inst) {
                inst.on(e,fn);
            }

            return this;
        }

        this.off = function (e, fn) {
            if (inst) {
                inst.off(e, fn);
            }

            return this;
        }

        this.create = function() {
           // inst = $(el).data("scroller");
            
            if (!inst) {

                if (uiGlobal.support.nativeScroll) {
                    inst = new NativeScrolling(el, options);
                } else {
                    inst = new IScrollScrolling(el, options);
                }
                
             //   $(el).data("scroller", inst);
            } else {

                this.refresh();
               // $(el).data("scroller", inst);
            }
        }

        this.create();

        return this;
    }

    return Scroll;
});


