﻿(function () {
    var scriptPostfix = "";
    requirejs.config({
        paths: {
            'jquery': 'lib/jquery-2.0.3', //  + scriptPostfix,
            'text': 'lib/text' + scriptPostfix,
            'app': 'app' + scriptPostfix,
            'underscore': 'lib/underscore' + scriptPostfix,
            'backbone': 'lib/backbone' + scriptPostfix,
            'validation': 'lib/backbone.validation' + scriptPostfix,
            'settings': 'settings' + scriptPostfix,
            'templates': '../../templates/v0004',
            'helper': 'helper' + scriptPostfix,

            // adapters
            'localStorage': 'adapters/localStorageAdapter',
            'api': 'adapters/apiAdapter',
            'preferences': 'adapters/userStorageAdapter',
            'cache': 'adapters/cacheAdapter',
            'device': 'adapters/deviceAdapter',
            'tracking': 'adapters/trackingAdapter.ga',
            'logger': 'adapters/loggerAdapter.console',
            
            // ui
            'template': 'ui/template',
            'libSnap': 'lib/snap',
            'libHammer': 'lib/jquery.hammer-full' + scriptPostfix,
            'libIScroll': 'lib/iscroll/iscroll-probe' + scriptPostfix,
            'uiScroll':'lib/scroll',
            'uiTimeAgo': 'lib/jquery.timeago',
            'uiContainers': 'ui/containers',
            'uiPageTransition': 'ui/page-transition',
            'uiValidation': 'ui/validation',
            'uiGlobal': 'ui/global',
            'uiModal': 'ui/modal',
            'uiToast': 'ui/toast',
            'uiDialog': 'ui/dialog',
            'uiSlider': 'ui/slider',
            'uiSpinner': 'ui/spinner',
            'uiSwipe': 'lib/swipe',
            'uiFingerblast': 'ui/fingerblast',
            'uiBackdrop': 'ui/backdrop',
            'uiSocialShare': 'ui/social-share',
            'uiControlBase': 'ui/controls/base',
            'uiControlBaseContainer': 'ui/controls/baseContainer',
            'uiControlButton': 'ui/controls/button',
            'uiControlTile': 'ui/controls/tile',
            'uiControlLoader': 'ui/controls/loader',
            'uiControlSelectList': 'ui/controls/select-list',
            'uiControlEditorText': 'ui/controls/editor-text',
            'uiControlEditorSelectSingle': 'ui/controls/editor-select-single',
            'uiControlEditorSelectMultiple': 'ui/controls/editor-select-multiple',
            'uiControlEditorTextArea': 'ui/controls/editor-text-area',
            'uiControlEditorCheckBox': 'ui/controls/editor-checkbox',
            'uiControlEditorOfferCategory': 'ui/controls/editor-offer-category',
            'uiControlEditorOfferImage': 'ui/controls/editor-offer-image',
            'uiControlEditorOfferImageGallery': 'ui/controls/editor-offer-image-gallery',
            'uiControlEditorLocation': 'ui/controls/editor-location',
            'uiControlDialogOptions': 'ui/controls/dialog-options',
            'uiControlViewSlider': 'ui/controls/view-slider',
            'uiControlViewImage': 'ui/controls/view-image',
            'uiControlViewList': 'ui/controls/view-list',
            'uiControlViewOfferListItem': 'ui/controls/view-offer-list-item',

            // globalization
            'libGlobalize': 'lib/globalize/globalize' + scriptPostfix,
            'culture.en': 'lib/globalize/cultures/globalize.culture.en-GB',
            'culture.en.messages': 'lib/globalize/cultures/messages.en-GB',
            'culture.en.timeago': 'lib/globalize/cultures/jquery.timeago.en',
            'culture.fa': 'lib/globalize/cultures/globalize.culture.fa-IR',
            'culture.fa.messages': 'lib/globalize/cultures/messages.fa-IR',
            'culture.fa.timeago': 'lib/globalize/cultures/jquery.timeago.fa',
            'globalize': 'globalize'
        },
        shim: {
            'jquery': {
                exports: '$'
            },
            'underscore': {
                exports: '_'
            },
            'backbone': {
                deps: ['underscore', 'jquery'],
                exports: 'Backbone'
            },
            'libSnap':{
                exports: 'Snap'
            },
            'app': {
                deps: ['jquery', 'underscore', 'backbone', 'text','validation']
            },
            'libGlobalize': {
                exports: 'Globalize'
            },
            'uiSwipe': {
                exports: 'Swiper'
            },
            'libIScroll': {
                exports: 'IScroll'
            }
        }
    });
}());

define(['jquery', 'app'], function ($, app) {

    if (typeof device !== 'undefined' && device.available) {
        document.addEventListener('deviceready', __t, false);
    } else {
        __t();
    }

    function __t() {
        $(function () {
            app.initialize();


        });
    }
       
    


});
