﻿define([
  'models/base', 'api', 'globalize'
], function (ModelBase, api, globalize) {

    var translate = globalize.localizeBase("views.feedback.validation");

    var Model = ModelBase.extend({
        defaults: {
            email: "",
            subject: "",
            message: ""
        },
        validation: {
            email: {
                required: true,
                msg: function () {
                    return translate("email.required");
                }
            },
            subject: {
                required: true,
                msg: function () {
                    return translate("subject.required");
                }
            },
            message: {
                required: true,
                msg: function () {
                    return translate("message.required");
                }
            }
        },
        url: function () {
            return null;
        },
        save: function (data) {
            this.set(data);
            if (!this.isValid(true)) return false;
            var result = $.Deferred();
            api.feedback.send(data).fail(function (data, xhr) {
                result.reject(xhr, data)
            }).done(function (data) {
                result.resolve(data);
            });

            return result;
        }
    });

    return Model;
});