﻿define([
  'models/base', 'globalize'
], function (ModelBase, globalize) {

    var translate = globalize.localizeBase("views.login.validation");

    var Model = ModelBase.extend({
        defaults: {
            email: "",
            password: ""
        },
        validation: {
            email: {
                required: true,
                msg: function () {
                    return translate("email.required");
                }
            },
            password: {
                required: true,
                msg: function () {
                    return translate("password.required");
                }
            }
        },
        url: "/user/login"
    });

    return Model;
});