﻿define([
  'models/base', 'globalize'
], function (ModelBase, globalize) {

    var translate = globalize.localizeBase("views.me.change-password.validation");

    var Model = ModelBase.extend({
        defaults: {
            oldPassword: "",
            newPassword: "",
            newPasswordRepeat: ""
        },
        validation: {
            oldPassword: {
                required: true,
                msg: function () {
                    return translate("old-password.required");
                }
            },
            newPassword: {
                required: true,
                msg: function () {
                    return translate("new-password.required");
                }
            },
            newPasswordRepeat: {
                required: true,
                msg: function () {
                    return translate("new-password-repeat.required");
                }
            }
        },
        url: "/user/me/change-password"
    });

    return Model;
});