﻿define([
  'models/base', 'globalize'
], function (ModelBase, globalize) {

    var translate = globalize.localizeBase("views.me.offer-edit.validation");

    var Model = ModelBase.extend({
        defaults: {
            category: null,
            categoryDummy:null
        },
        validation: {
            categoryDummy: {
                fn: function (valueDummy, attr, context) {
                    value = context.category;
                    if (!this.isValidCategory(value)) {
                        return translate("category.required");
                    }
                }
            }
        },
        isValidCategory: function (value) {
            if (!value || !value.id || value.childrenCount > 0) {
                return false;
            }
            return true;
        }
    });

    return Model;
});