﻿define([
  'models/base', 'globalize'
], function (ModelBase, globalize) {

    var translate = globalize.localizeBase("views.me.offer-edit.validation");

    var Model = ModelBase.extend({
        defaults: {
            mobile: null,
            landline1:null,
            landline2:null,
        },
        validation: {
            mobile: [{
                required: false,
            },{
                pattern: "^[0-9]+$",
                msg: function () {
                    return translate("contact.mobile.invalid");
                }
            }],
            landline1: [{
                required: false,
            }, {
                pattern: "^\\+?[0-9]+$",
                msg: function () {
                    return translate("contact.landline1.invalid");
                }
            }],
            landline2: [{
                required: false,
            }, {
                pattern: "^\\+?[0-9]+$",
                msg: function () {
                    return translate("contact.landline2.invalid");
                }
            }]
        }
    });

    return Model;
});