﻿define([
  'models/base', 'globalize'
], function (ModelBase, globalize) {

    var translate = globalize.localizeBase("views.me.offer-edit.validation");

    var Model = ModelBase.extend({
        defaults: {
            name: null,
            images: null,
            description: null,
            //contactName: null,
            mobile: null,
            landline1:null,
            landline2:null,
            category: null,
            location: null,
            attributes:null
        },
        validation: {
            name: {
                required: true,
                msg: function () {
                    return translate("name.required");
                }
            },
            description: {
                required: true,
                msg: function () {
                    return translate("description.required");
                }
            },
            category: {
                fn: function (value, attr, context) {
                    if (!value) return translate("category.required");;
                }
            },
            location: {
                fn: function (value, attr, context) {
                    if (!value) return translate("location.required");;
                }
            }
        },
        attachAttributeValidation: function (values) {
            var model = this;
            if (!values) return;
            var attributeValues = {};
            var attributes = {};
            
            $.each(values, function (i, value) {
                var key = "attribute_" + value.id;
                attributes[key] = value;
                attributeValues[key] = value.value;
                model.validation[key] = {
                    fn: function (a, b, c) {
                        var val = attributes[key];
                        if (!val) return false;
                        if (val.required && !val.values) return translate("attribute.required");
                        return false;
                    }
                };
            });

            return attributeValues;
        },
        
        urlRoot: "/user/offer"
    });

    return Model;
});