﻿define([
  'models/base', 'api', 'globalize'
], function (ModelBase, api, globalize) {

    var translate = globalize.localizeBase("views.offer.view-message.validation");

    var Model = ModelBase.extend({
        defaults: {
            message: "",
            sendCopy: false,
            email:""
        },
        validation: {
            message: {
                required: true,
                msg: function () {
                    return translate("message.required");
                }
            },
            email: {
                required: true,
                msg: function () {
                    return translate("email.required");
                }
            }
        },
        url: function () {
            return null;
        },
        save: function (data) {
            this.set(data);
           
            if (!this.isValid(true)) return false;
            var result = $.Deferred();
            api.offer.sendMessage(data.offerId, data).fail(function (data, xhr) {
                result.reject(xhr,data)
            }).done(function (data) {
                result.resolve(data);
            });

            return result;
        }
    });

    return Model;
});