﻿define(["jquery", "underscore", "uiPageTransition","uiGlobal"],
        function ($, _, uiPageTransition,uiGlobal) {

            function Backdrop() {
                var el = null;

                function show() {
                    if (el) return;

                    el = $("<div class=\"backdrop off\" />");

                    uiGlobal.$body.append(el);

                    var deferred = uiGlobal.transition(el, "opacity 0.3s ease").done(function () {
                    });

                    el[0].offsetWidth;
                    el.removeClass("off");

                    return deferred;
                }

                function hide() {
                    if (!el) return;

                    var deferred = uiGlobal.transition(el, "opacity 0.3s ease").done(function () {
                        el.remove();
                        el = null;
                    });
                    el.addClass("off");

                    return deferred;
                }

                this.show = show;
                this.hide = hide;
            }

            return new Backdrop();
        }
);