﻿define(["jquery", "underscore","backbone"],
        function ($, _,Backbone) {

            var Control = function () {
                this.initialize.apply(this, arguments); 
            }

            _.extend(Control.prototype, Backbone.Events, {
                container: null,
                el: null,
                options : null,
                template: null,
                _created:false,
                initialize: function (options) {
                    this.options = options || {};

                    if (this.options.container) this.container = this.options.container;
                },
                onBeforeRender: function (el, html, renderData) {

                },
                onRender: function (el, html, renderData) {

                },
                onBeforeDestory: function () {

                },
                getRenderData: function () {
                    return this.options;
                },
                destroy: function () {
                    this.onBeforeDestory();
                    if (this.el) {
                        this.el.remove();
                        this.el = null;
                    }

                    this.stopListening();
                    this.container = null;
                    this._created = false;

                    return this;
                },
                createIn: function (options, container) {
                    if (!container && !this.container) return this;
                    this.container = container||this.container;
                    this.options = _.extend({},this.options,options);

                    var template = this.options.template || this.template;

                    var renderData = this.getRenderData();
                    
                    var html = template(renderData);
                    this.el = $(html);
                    this.onBeforeRender(this.el, html, renderData);
                    if (!this.options.fnCreate) {
                        this.container.append(this.el);
                    } else {
                        this.options.fnCreate(this.container, this.el);
                    }
                    this.onRender(this.el, html, renderData);

                    this._created = true;

                    return this;
                },
                created: function () {
                    return this._created;
                }
            });

            Control.extend = Backbone.View.extend;

            return Control;
        }
);