﻿define([
  'jquery',
  'underscore',
  'uiControlBase'
], function ($, _, uiControlBase) {

    var Control = uiControlBase.extend({
        _controlContainer: [],
        registerControl: function (control) {
            if (!control || !this._controlContainer) return this;
            this._controlContainer.push(control);

            return this;
        },
        unregisterControls: function () {

            if (this._controlContainer && this._controlContainer.length > 0) {
                this._controlContainer = $.map(this._controlContainer, function (o) {
                    if (o || o.destroy) {
                        o.destroy();
                        o = null;
                        return null;
                    }
                    return o;
                });
            };

            return this;
        }
    });

    return Control;
});