﻿define([
  'jquery',
  'underscore',
  'globalize',
  'template',
  'uiGlobal',
  'uiControlBase',
  'libHammer'
], function ($, _, globalize, template, uiGlobal, uiControlBase,Hammer) {

    var Button = uiControlBase.extend({
        template: template.controls.button,
        getRenderData: function () {
            return this.options;
        },
        onBeforeDestory: function () {
            if (this.el) {
                this.el.off(uiGlobal.event.tap);
            }
        },
        onRender: function () {
            if (!this.el) return this;
            var self = this;

            this.el.hammer({
                //prevent_default: true
            }).on(uiGlobal.event.tap, function (e) {
                e.preventDefault();
                e.stopPropagation();
                if (e && e.gesture) {
                    e.gesture.preventDefault();
                }
                if (self && self.el) {
                //    self.el.toggleClass("highlite", true);
                }
                self.trigger("select", self);
            });
        }
    });

    return Button;
});