﻿define(["jquery", "underscore","template",'uiGlobal','libHammer'],
        function ($, _, template, uiGlobal,Hammer) {

            function DialogOptions() {
                var container;
                var self = this;
                var data = null;

                function open(options) {
                    var deferred = $.Deferred();
                    options = $.extend({}, {
                    }, options);

                    if (!options.template) {
                        options.template = template.controls.dialogOptions;
                    }

                    data = options.items;

                    var templateData = {
                        title: options.title,
                        items: $.map(options.items, function (o) {
                            return {
                                icon: o.icon || null,
                                name: o.name,
                                href:o.href||null,
                                cssClass:o.cssClass||"btn btn-primary"
                            }
                        })
                    }

                    container = $("<div class=\"dialog-options off\" />");
                    container.html(options.template(templateData));
                    uiGlobal.$body.append(container);

                    uiGlobal.$body.hammer({
                      //  prevent_default: true
                    }).on(uiGlobal.event.tap + ".dialogoptions", function (e) {
                        //  uiGlobal.touch(e, function (e) {
                            e.preventDefault();
                            close().always(function () {
                                deferred.reject();
                            });
                    //    });
                    });

                    $(".wrapper",container).hammer({
                       // prevent_default: true
                    }).on(uiGlobal.event.tap + ".dialogoptions", function (e) {
                        //  uiGlobal.touch(e, function (e) {
                            e.preventDefault();
                            e.stopPropagation();
                      //  });
                    });
                    

                    $("a", container).hammer({
                      //  prevent_default: true
                    }).on(uiGlobal.event.tap + ".dialogoptions", function (e) {
                        // uiGlobal.touch(e, function (e) {
                            e.preventDefault();
                            var trigger = $(e.target);
                            var index = trigger.data("index");

                            // get data
                            var selected = null
                            if (data && index < data.length) {
                                selected = data[index];
                            }

                            if (options.onSelect) {
                                if (options.onSelect(selected) === false) {
                                    deferred.reject(selected);
                                    return;
                                }
                            }

                            deferred.resolve(selected);

                            close();
                      //  });
                    });

                    // start transition
                    uiGlobal.transition(container, "bottom 0.3s ease",300);

                    container[0].offsetWidth;
                    container.removeClass("off");

                    return deferred;
                }

                function close(noanimation) {
                   
                    var deferred = $.Deferred();
                    if (!container) return deferred.fail();

                    if (noanimation) {
                        destroy();
                        deferred.resolve();
                    } else {
                        // start transition
                        uiGlobal.transition(container, "bottom 0.3s ease", 300).always(function () {
                            destroy();
                            deferred.resolve();
                        });

                        container[0].offsetWidth;
                        container.addClass("off");
                        
                    }

                    return deferred;
                }

                function destroy() {
                    // unbind stuff
                    if (container)
                    {
                        container.off(".dialogoptions");
                        container.remove();
                        container = null;
                    }
                    uiGlobal.$body.off(".dialogoptions");
                }

                this.open = open;
                this.close = close;
            }

            return DialogOptions;
        }
);