﻿define(["jquery", "underscore","template",'uiGlobal'],
        function ($, _, template, uiGlobal) {

            function EditorCheckBox(options) {
                var container;
                var _value = false;
                var self = this;
                var data = null;

                options = $.extend({}, {
                    template: template.controls.editorCheckbox
                }, options);

                function render(v) {
                    data = $.extend({}, {
                        required:false,
                        label: "",
                        icon: null
                    }, v);

                    
                    return options.template(data);
                }

                function create(c) {
                    container = c;
                    
                    container.hammer().on(uiGlobal.event.tap, function (e) {
                        e.preventDefault();
                        e.stopPropagation();

                        self.val(!self.val());
                    });
                    
                    renderValue(_value);
                }

                function destroy() {
                    // unbind stuff
                    if (container)
                    {
                        container.off(uiGlobal.event.tap);
                        container = null;
                    }
                    this.data = null;
                }

                function val(value) {
                    if (typeof value === 'undefined') return _value;
                    _value = value;
                    renderValue(value);
                }

                function renderValue(value) {
                    if (container) {
                        container.toggleClass("selected", !!value);
                    }
                }

                this.render = render;
                this.create = create;
                this.destroy = destroy;
                this.val = val;
            }

            return EditorCheckBox;
        }
);