﻿define(["jquery", "underscore","template",'uiGlobal','uiModal','globalize'],
        function ($, _, template, uiGlobal, uiModal, globalize) {
            var itemTemplate = _.template("<a><i class=\"icon icon-chevron\"></i><span data-role=\"text\"><%=text%></span></a>");

            function EditorSelectSingle(options,callerView) {
                var container;
                var elSelected;
                var self = this;
                var data = null;
                var selected = null;
                var valueContainer = null;

                options = $.extend({}, {
                    template: template.controls.editorList
                }, options);

                function render(renderData) {
                    data = $.extend({}, {
                        required:false,
                        label: "",
                        icon: null,
                        value: null,
                        name: null,
                        id:null
                    }, renderData);

                    return options.template(data);
                }

                function create(o) {
                    container = o;
                    container.hammer({
                       // prevent_default: true
                    }).on(uiGlobal.event.tap + ".editorselectsingle", function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                      //  uiGlobal.touch(e, function (e) {
                            open();
                      //  });
                    });

                    valueContainer = $("[data-role='text']", container);
                }

                function open() {
                    
                    uiModal.openSelectList({
                        type: "single",
                        title: data.listTitle,
                        list:  data.list,
                        onSelect: function (data) {
                            select(data);
                        }
                    }, callerView);
                }

                function select(value) {
                    if (data.onSelect && data.onSelect(value) === false) return;
                    val(value);
                }

                function val(value) {
                    if (typeof value === 'undefined') return selected;

                    selected = value;
                    renderVal(value);
                }

                function renderVal(value) {
                    valueContainer.empty();
                   
                    var el = null;
                    if (!value) {
                        el = $(itemTemplate({
                            text: globalize.localize("views.shared.select.message"),
                        }));
                    } else {
                        el = $(itemTemplate({
                            text: value.title
                        }));
                    }
                    valueContainer.append(el);
                }


                function destroy() {
                    // unbind stuff
                    if (container)
                    {
                        container.off(".editorselectsingle");
                    }
                    data = null;
                    elSelected = null;
                    valueContainer = null;

                }
                
                this.render = render;
                this.create = create;
                this.destroy = destroy;
                this.val = val;
            }

            return EditorSelectSingle;
        }
);