﻿define(["jquery", "underscore","template",'uiGlobal'],
        function ($, _, template, uiGlobal) {

            function EditorText(options) {
                var container;
                var self = this;
                var data = null;

                if (!options.template) {
                    options.template = template.controls.editorText;
                }

                function render(data) {
                    data = $.extend({}, {
                        placeholder: "",
                        required: false,
                        label: "",
                        icon: null,
                        value: null
                    }, data);

                    this.data = data;
                    return options.template(data);
                }

                function create(c) {
                    container = c;
                }

                function destroy() {
                    // unbind stuff
                    if (container) {
                        container.off(".editortextarea");
                    }

                    this.data = null;
                }

                function val() {
                    if (typeof value === 'undefined') return $("textarea", container).val();

                    $("textarea", container).val(value);
                }

                this.render = render;
                this.create = create;
                this.destroy = destroy;
                this.val = val;
            }

            return EditorText;
        }
);