﻿define(["jquery", "underscore","template",'uiGlobal'],
        function ($, _, template, uiGlobal) {

            function SelectList(options) {
                var container;
                var elSelected;
                var self = this;

                options = $.extend({}, {
                    type: "single",
                    list:function(data){
                        if (data.list) return data.list;
                        return data;
                    },
                    data: {}
                }, options);

                if (!options.template) {
                    options.template = template.controls.selectList;
                }

                function render(d) {
                    this.data = d;
                    this.data.markerIcon = (options.type == "single") ? "icon-radiobox" : "icon-checkbox";
                    return options.template(d);
                }

                function selected() {
                    if (options.type == 'multiple') {
                        elSelected = $("a.selected", container);
                    }
                    if (!elSelected) return null;

                    var result = $.map(elSelected, function (o, i) {
                        var el = $(o);

                        var index = el.data("index");
                        
                        if (typeof index === "undefined" || index === null || index < 0) return null;

                        var list = options.list(self.data);

                        if (index >= list.length) return null;

                        var item = list[index];

                        return item;
                    });

                    if (options.type == "single") {
                        if (result.length == 0) return null;
                        return result[0];
                    }
                    
                    return result;
                }

                function create(o) {
                    container = o;

                    elSelected = $("a.selected", container);
                    $("a", container).hammer({
                       // prevent_default: true
                    }).on(uiGlobal.event.tap + ".selectlist", function (e) {
                        //  uiGlobal.touch(e, function (e) {
                            e.preventDefault();
                            e.stopPropagation();
                            var btn = $(this);
                            
                            if (options.type == "single") {
                                // if selected, do nothing

                                if (btn == elSelected) return;

                                // unselect current
                                if (elSelected) elSelected.toggleClass("selected", false);

                                // select
                                btn.toggleClass("selected", true);

                                elSelected = btn;
                                if (options.onSelect) {
                                    options.onSelect(self.selected(), elSelected, self.data);
                                }
                            }
                            if (options.type == "multiple") {

                                // select
                                btn.toggleClass("selected");
                            }
                       // });
                    })
                }

                function createIn(options,container) {
                    create(container);
                }

                function destroy() {
                    // unfind stuff
                    if (container)
                    {
                        container.off(".selectlist");
                    }

                    elSelected = null;

                    this.el = null;
                    this.data = null;
                }

                this.render = render;
                this.create = create;
                this.destroy = destroy;
                this.selected = selected;
                this.data = null;

                this.createIn = createIn;
            }

            return SelectList;
        }
);