﻿define(["jquery", "underscore", "template", 'uiGlobal'],
        function ($, _, template, uiGlobal) {

            var template = _.template("<div class=\"image\"></div>");

            function ViewImage() {
                var container;
                var data = null;
                var el = null;
                var _loaded = false;
                var deferred = null;

                function createIn(opt, cont) {
                    container = cont;
                    data = $.extend({}, {
                        template: template
                    }, opt);

                    var html = data.template({
                        src:data.src
                    });

                    el = $(html);
                    container.append(el);

                    return html;
                }
               
                function destroy() {
                    // unbind stuff
                    if (container) {
                        container.off(".viewimage");
                    }
                    if (el) {
                        el.remove();
                        el = null;
                    }
                    deferred = null;
                    data = null;
                }

                function load() {
                    if (deferred) return deferred;
                    
                    deferred = $.Deferred();

                    el.html("<i class=\"icon icon-spinner\"></i>");

                    var img = new Image();
                    img.onload = function () {
                        deferred.resolve();
                    }
                    img.onerror = function () {
                        deferred.reject();
                    }

                    img.src = data.src;

                    return deferred.always(function () {
                        _loaded = true;
                    }).done(function () {
                        renderImg();
                    });
                }

                function renderImg() {
                    el.html("<img src=\"" + data.src + "\" />");
                }

                this.createIn = createIn;
                this.destroy = destroy;
                this.load = load;
                this.container = function () {
                    return container;
                }
                this.el = function () {
                    return el;
                }
            }

            return ViewImage;
        }
);