﻿define([
  'jquery',
  'underscore',
  'api',
  'globalize',
  'template',
  'uiControlBase'
], function ($, _, api, globalize, template, uiControlBase) {

    var Control = uiControlBase.extend({
        template: _.template("<div class=\"list\" />"),
        _controlContainer: [],
        items: [],
        initialize: function (options) {
            this.constructor.__super__.initialize.call(this);

            var self = this;
            this.options = $.extend({}, {
            }, options);

            if (this.options.container) this.container = this.options.container;
            if (this.options.template) this.template = this.options.template;
            this.createItem = this.options.createItem || this.createItem;
        },
        getRenderData: function () {
            return this.options;
        },
        onBeforeDestory: function () {
            this.unregisterControls();
        },
        onRender: function () {

            var self = this;
            if (this._controlContainer) {
                _.each(this._controlContainer, function (o) {
                    o.createIn({}, self.el);
                });
            }
        },
        visible:function(){

        },
       
        registerControl: function (control) {
            if (!control || !this._controlContainer) return this;
            this._controlContainer.push(control);

            return this;
        },
        createItem: function (data) {
            var item = new uiControlButton();

            return item;
        },
        unregisterControls: function () {

            if (this._controlContainer && this._controlContainer.length > 0) {
                this._controlContainer = $.map(this._controlContainer, function (o) {
                    if (o || o.destroy) {
                        o.destroy();
                        o = null;
                        return null;
                    }
                    return o;
                });
            };

            return this;
        }
    });

    return Control;
});