﻿define(["jquery", "underscore", "template", 'uiGlobal', 'uiModal', 'uiSwipe'],
        function ($, _, template, uiGlobal, uiModal, uiSwipe) {

            function ViewSlider() {
                var container;
                var data = null;
                var el = null;
                var swiper = null;

                function createIn(opt, cont) {
                    container = cont;
                    data = $.extend({}, {
                        template: template.controls.viewSlider
                    }, opt);

                    var html = data.template(data);

                    el = $(html);
                    container.append(el);

                    var pager =  $(".swiper-pagination",el); 

                    (pager.length ==0)?pager=null:pager=pager[0];

                    swiper = new uiSwipe(el[0], {
                        pagination: pager,
                        loop: false,
                        centeredSlides: true,
                     //   slidesPerView: "auto",
                      //  watchActiveIndex: true
                    });

                    return html;
                }
               
                function destroy() {
                    // unbind stuff
                    if (swiper) {
                        swiper = null;
                    }

                    if (container) {
                        container.off(".viewslider");
                    }
                    if (el) {
                        el.remove();
                        el = null;
                    }
                    data = null;
                }

                this.createIn = createIn;
                this.destroy = destroy;
                this.container = function () {
                    return container;
                }
            }

            return ViewSlider;
        }
);