﻿define(["jquery", "underscore", "uiPageTransition","uiControlDialogOptions","uiBackdrop","logger"],
        function ($, _, uiPageTransition,uiControlDialogOptions,uiBackdrop,logger) {

            function SocialShare() {

                function available() {
                    return isNative();
                }

                function isNative() {
                    return window.plugins && window.plugins.socialsharing;
                }

                function share(message, subject, file, url) {
                    var deferred = $.Deferred();
                    if (!isNative()) {
                        logger.warn("Social sharing is not supported! Subject: " + subject + " Message: " + message + " File: " + file + " Url: " + url);
                        deferred.reject();
                        return deferred;
                    }

                    window.plugins && window.plugins.socialsharing.share(message, subject, file, url, function () {
                        deferred.resolve();
                    }, function () {
                        deferred.reject();
                    });

                    return deferred;
                }

                this.available = available;
                this.share = share;
            }

            return new SocialShare();
        }
);