﻿define([
    "underscore",
    'text!templates/home.html',
    'text!templates/forgot-password.html',
    'text!templates/login.html',
    'text!templates/register.html',
    'text!templates/terms-of-service.html',
    'text!templates/feedback.html',
    'text!templates/privacy-policy.html',
    'text!templates/doping-info.html',
    'text!templates/_empty.html',
    'text!templates/_header-default.html',
    'text!templates/_footer-default.html',
    'text!templates/_header-ok-cancel.html',
    'text!templates/_snap-primary.html',

    'text!templates/me/profile.html',
    'text!templates/me/change-password.html',
    'text!templates/me/change-email.html',
    'text!templates/me/change-language.html',
    'text!templates/me/about-device.html',
    'text!templates/me/offer.html',
    'text!templates/me/offer-view.html',
    'text!templates/me/offer-edit.html',
    'text!templates/me/offer-edit-text.html',
    'text!templates/me/offer-edit-contact.html',
    'text!templates/me/offer-edit-gallery.html',
    'text!templates/me/offer-edit-attributes.html',
    'text!templates/me/offer-edit-doping.html',
    'text!templates/me/offer-edit-doping-duration.html',
    'text!templates/me/offer-edit-doping-bank.html',
    'text!templates/me/offer-edit-doping-confirm.html',
    'text!templates/me/message.html',
    'text!templates/me/message-view.html',
    'text!templates/me/payment.html',
    'text!templates/me/_payment-list-item.html',
    'text!templates/me/_message-list-item.html',
    'text!templates/me/_offer-list-item.html',

    'text!templates/offer/search.html',
    'text!templates/offer/search-filter.html',
    'text!templates/offer/favorites.html',
    'text!templates/offer/hot.html',
    'text!templates/offer/view.html',
    'text!templates/offer/view-message.html',
    'text!templates/offer/_list-item.html',
    'text!templates/offer/_attributes.html',
    'text!templates/offer/search-filter-price-range.html',

    'text!templates/controls/button.html',
    'text!templates/controls/tile.html',
    'text!templates/controls/modal.html',
    'text!templates/controls/select-list.html',
    'text!templates/controls/select-list-item.html',
    'text!templates/controls/editor-text.html',
    'text!templates/controls/editor-range.html',
    'text!templates/controls/editor-checkbox.html',
    'text!templates/controls/editor-list.html',
    'text!templates/controls/editor-text-area.html',
    'text!templates/controls/dialog-options.html',
    'text!templates/controls/view-slider.html'
],
    function (_,
        home,
        forgotPassword,
        login,
        register,
        tos,
        feedback,
        privacyPolicy,
        dopingInfo,
        _empty,
        _headerDefault,
        _footerDefault,
        _headerOkCancel,
        _snapPrimary,
        meProfile,
        meChangePassword,
        meChangeEmail,
        meChangeLanguage,
        meAboutDevice,
        meOffer,
        meOfferView,
        meOfferEdit,
        meOfferEditText,
        meOfferEditContact,
        meOfferEditGallery,
        meOfferEditAttributes,
        meOfferEditDoping,
        meOfferEditDopingDuration,
        meOfferEditDopingBank,
        meOfferEditDopingConfirm,
        meMessage,
        meMessageView,
        mePayment,
        me_paymentListItem,
        me_messageListItem,
        me_offerListItem,
        offerSearch,
        offerSearchFilter,
        offerFavorites,
        offerHot,
        offerView,
        offerViewMessage,
        offer_listItem,
        offer_attributes,
        offerSearchFilterPriceRange,
        controlsButton,
        controlsTile,
        controlsModal,
        controlsSelectList,
        controlsSelectListItem,
        controlsEditorText,
        controlsEditorRange,
        controlsEditorCheckbox,
        controlsEditorList,
        controlsEditorTextArea,
        controlsDialogOptions,
        controlsViewSlider
        ) {

        var container = {};
        container.offer = {};
        container.controls = {};
        container.me = {};

        container.forgotPassword = _.template(forgotPassword);
        container.home = _.template(home);
        container.login = _.template(login);
        container.register = _.template(register);
        container.tos = _.template(tos);
        container.privacyPolicy = _.template(privacyPolicy);
        container.feedback = _.template(feedback);
        container.dopingInfo = _.template(dopingInfo);
        container._empty = _.template(_empty);
        container._headerDefault = _.template(_headerDefault);
        container._footerDefault = _.template(_footerDefault);
        container._headerOkCancel = _.template(_headerOkCancel);
        container._snapPrimary = _.template(_snapPrimary);

        container.me.profile = _.template(meProfile);
        container.me.changePassword = _.template(meChangePassword);
        container.me.changeEmail = _.template(meChangeEmail);
        container.me.changeLanguage = _.template(meChangeLanguage);
        container.me.aboutDevice = _.template(meAboutDevice);
        container.me.offer = _.template(meOffer);
        container.me.offerView = _.template(meOfferView);
        container.me.offerEdit = _.template(meOfferEdit);
        container.me.offerEditText = _.template(meOfferEditText);
        container.me.offerEditContact = _.template(meOfferEditContact);
        container.me.offerEditGallery = _.template(meOfferEditGallery);
        container.me.offerEditAttributes = _.template(meOfferEditAttributes);
        container.me.offerEditDoping = _.template(meOfferEditDoping);
        container.me.offerEditDopingDuration = _.template(meOfferEditDopingDuration);
        container.me.offerEditDopingBank = _.template(meOfferEditDopingBank);
        container.me.offerEditDopingConfirm = _.template(meOfferEditDopingConfirm);
        container.me.message = _.template(meMessage);
        container.me.messageView = _.template(meMessageView);
        container.me.payment = _.template(mePayment);
        container.me._paymentListItem = _.template(me_paymentListItem);
        container.me._messageListItem = _.template(me_messageListItem);
        container.me._offerListItem = _.template(me_offerListItem);

        container.offer.search = _.template(offerSearch);
        container.offer.searchFilter = _.template(offerSearchFilter);
        container.offer.favorites = _.template(offerFavorites);
        container.offer.hot = _.template(offerHot);
        container.offer.view = _.template(offerView);
        container.offer.viewMessage = _.template(offerViewMessage);
        container.offer._listItem = _.template(offer_listItem);
        container.offer._attributes = _.template(offer_attributes);
        container.offer.searchFilterPriceRange = _.template(offerSearchFilterPriceRange);

        container.controls.button = _.template(controlsButton);
        container.controls.tile = _.template(controlsTile);
        container.controls.modal = _.template(controlsModal);
        container.controls.selectList = _.template(controlsSelectList);
        container.controls.selectListItem = _.template(controlsSelectListItem);
        container.controls.editorText = _.template(controlsEditorText);
        container.controls.editorRange = _.template(controlsEditorRange);
        container.controls.editorCheckbox = _.template(controlsEditorCheckbox);
        container.controls.editorList = _.template(controlsEditorList);
        container.controls.editorTextArea = _.template(controlsEditorTextArea);
        container.controls.dialogOptions = _.template(controlsDialogOptions);
        container.controls.viewSlider = _.template(controlsViewSlider);
        
        return container;
    }
);



