﻿define([
  'jquery',
  'underscore',
  'globalize',
  'api',
  'models/feedback',
  'views/base',
  'uiToast',
  'template',
  'uiGlobal'
], function ($, _, globalize, api, Model, ViewBase, uiToast, template,uiGlobal) {

    var translate = globalize.localizeBase("views.feedback");
    var translateShared = globalize.localizeBase("views.shared");

    var View = ViewBase.extend({
        validatorSelectorMask: "[name='&']",
        currentUser:null,
        initialize: function () {
            this.constructor.__super__.initialize.call(this);
            
            this.title = translate("title");
            this.setModel(new Model());

            api.me.get().done(_.bind(function (user) {
                this.currentUser = user;
            }, this)).always(_.bind(function () {
                this.render();
            },this));

        },
        renderTemplate: function () {
            return template.feedback({
                translate: translate,
                email:(this.currentUser?this.currentUser.email:null)
            });
        },
        save: function (e) {
           var self = this;
          
           this.saveModel({
                email: (this.currentUser?this.currentUser.email:this.$("[name='email']").val()),
                subject: this.$("[name='subject']").val(),
                message: this.$("[name='message']").val()
            }).done(function (data) {
                uiToast.success(translate("success.info"));
                self.navigateBack();
            });

        },
        onpagerenderdone:function(){
           // this.$("#email").focus();
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("cancel"),
                cancelIcon: "icon-cancel",
                onCancel: $.proxy(function () {
                    this.navigate('');
                },this),
                okText: translateShared("accept"),
                okIcon: "icon-accept",
                onOk: _.bind(function (e) {
                    this.save();
                }, this),
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        }
    });
    return View;
});