﻿define([
  'jquery',
  'underscore',
  'globalize',
  'views/base',
  'uiToast',
  'models/forgot-password',
  'template',
  'uiGlobal'
], function ($, _, globalize, ViewBase, uiToast, Model, template, uiGlobal) {

    var translate = globalize.localizeBase("views.forgot-password");
    var translateShared = globalize.localizeBase("views.shared");

    var View = ViewBase.extend({
        events: {
            "submit form": "save"
        },
        initialize: function () {
            this.constructor.__super__.initialize.call(this);

            this.title = translate("title");
            this.setModel(new Model());
            this.render();
        },
        renderTemplate: function () {
            return template.forgotPassword({
                translate: translate
            });
        },
       
        save: function (e) {
            if (e) e.preventDefault();
            var self = this;

            var res = this.saveModel({
                email: this.$("#email").val(),
            }, this.$("form")).done(function (data) {
                uiToast.open({
                    content: translate("success-message")
                });
                self.navigateBack();
            });
        },
        onpagerenderdone: function () {
           // this.$("#email").focus();
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("close"),
                okEnabled:false
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        }
        
    });
    return View;
});