﻿define([
  'jquery',
  'underscore',
  'api',
  'views/base',
  'uiToast',
  'models/me/change-email',
  'template',
  'globalize'
], function ($, _, api, ViewBase, uiToast, Model, template, globalize) {

    var translate = globalize.localizeBase("views.me.change-email");
    var translateShared = globalize.localizeBase("views.shared");

    var View = ViewBase.extend({
        access: "auth",
        currentUser:null,
        initialize: function () {
            this.constructor.__super__.initialize.call(this);
            this.title = translate("title");
            this.setModel(new Model());
            
            this.load();
        },
        load:function(){
            
            api.me.get().done(_.bind(function (data) {
                this.currentUser = data;
                this.render();
            },this));

        },
        
        renderTemplate: function () {
            return template.me.changeEmail({
                oldEmail: this.currentUser.email,
                translate:translate
            });
        },
        save: function () {
            var self = this;

            var res = this.saveModel({
                email: this.$("#email").val(),
            }, this.$("form")).done(function (data) {
                uiToast.open(translate("success.info"));
                self.navigateBack();
            });
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("cancel"),
                cancelIcon: "icon-cancel",
                okText: translateShared("accept"),
                okIcon: "icon-accept",
                onOk: $.proxy(function (e) {
                    this.save();
                }, this)
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        }
        
    });
    return View;
});