﻿define([
  'jquery',
  'views/base',
  'uiToast',
  'template',
  'globalize',
  'uiGlobal',
  'uiContainers',
  'uiControlSelectList',
  'preferences'
], function ($, ViewBase, uiToast, template, globalize, uiGlobal,uiContainers, uiControlSelectList, preferences) {

    var translate = globalize.localizeBase("views.me.change-language");
    var translateShared = globalize.localizeBase("views.shared");

    var View = ViewBase.extend({
        listControl:null,
        initialize: function () {
            this.constructor.__super__.initialize.call(this);

            this.title = translate("title");

            this.render();
        },
        renderTemplate: function () {
            return template.me.changeLanguage({
            });
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("back"),
                okEnabled: false
            });
        },
        onpagerenderdone: function () {
            var container = this.$("[data-role='list']");
            listControl = new uiControlSelectList({
                type: "single",
                onSelect: _.bind(function (data, el, source) {
                    this.changeLanguage(data.value);
                },this)
            });

            var curentLanguage = globalize.culture().name;
            var data = {
                list: [
                    { selected: (curentLanguage == "en-GB"), name: "English", value: "en-GB" },
                    { selected: (curentLanguage == "fa-IR"), name: "Farsi", value: "fa-IR" }
                ]
            };
            var html = listControl.render(data);
            container.html(html);
            listControl.create(container);

        },
        changeLanguage:function(val){
            var culture = globalize.setCulture(val);

            // save to preferences
            preferences.language(culture.name);

            if (culture.isRTL) {
                uiGlobal.html.setAttribute("dir", "rtl");
            } else {
                uiGlobal.html.setAttribute("dir", "ltr");
            }
            uiGlobal.html.setAttribute("lang", culture.language);
            uiGlobal.$body.toggleClass("rtl", culture.isRTL).toggleClass("ltr", !culture.isRTL);

            uiContainers.snap.settings({
                disable: globalize.culture().isRTL ? 'left' : 'right'
            });

            uiToast.open({
                content: "Language was changed"
            });
            this.navigateBack();
        },
        initializeFooter: function (o) {
            o.viewNone();
        },
        onremoving: function () {
            if (this.listControl) {
                this.listControl.destory();
            }
        }
        
    });
    return View;
});