﻿define([
  'jquery',
  'underscore',
  'views/base',
  'uiToast',
  'models/me/change-password',
  'template',
  'globalize'
], function ($, _, ViewBase, uiToast, Model, template, globalize) {

    var translate = globalize.localizeBase("views.me.change-password");
    var translateShared = globalize.localizeBase("views.shared");

    var View = ViewBase.extend({
        access: "auth",
        initialize: function () {
            this.constructor.__super__.initialize.call(this);
            this.title = translate("title");
            this.setModel(new Model());
            this.render();
        },
        renderTemplate: function () {
            return template.me.changePassword({
                translate:translate
            });
        },
        save: function () {
            var self = this;
            
            var res = this.saveModel({
                oldPassword: this.$("#oldPassword").val(),
                newPassword: this.$("#newPassword").val(),
                newPasswordRepeat: this.$("#newPasswordRepeat").val(),
            }, this.$("form")).done(function (data) {
                uiToast.open(translate("success.info"));
                self.navigateBack();
            });
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("cancel"),
                cancelIcon: "icon-cancel",
                okText: translateShared("accept"),
                okIcon: "icon-accept",
                onOk: $.proxy(function (e) {
                    this.save();
                }, this)
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        }
        
    });
    return View;
});