﻿define([
  'jquery',
  'underscore',
  'api',
  'globalize',
  'views/base',
  'uiTimeAgo',
  'collections/me/message',
  'template',
  'helper'
], function ($, _, api, globalize, ViewBase, uiTimeago, Collection,template,helper) {
    var View = ViewBase.extend({
        title: "My messages",
        collection: null,
        apiData:null,
        initialize: function (options) {
            this.constructor.__super__.initialize.call(this);

            this.collection = new Collection();
            this.load();
        },
        load: function () {
            var self = this;

            this.apiData = {
                p: 1
            };

            // get from cache

            // load view from cache
            self.render();

            this.fetch({
                reset: true,
                data: this.apiData
            }, this.collection).done(function (data) {
                self.render();
            });
        },
        renderTemplate: function () {
            return template.me.message({
                list: this.collection.toJSON(),
                totalCount: this.collection.totalCount,
                renderItem: function (item) {
                    return template.me._messageListItem(
                         {
                             item:item,
                             format: function (val, f) {
                                 return globalize.format(val, f);
                             },
                             renderDate: function (val) {
                                 return uiTimeago.inWords(new Date().getTime() - helper.parseDate(val).getTime());
                             }
                         }
                    )
                    
                }
                
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        }
    });
    return View;
});