﻿define([
  'jquery',
  'underscore',
  'api',
  'uiDialog',
  'uiToast',
  'views/base',
  'template',
  'uiGlobal',
  'globalize',
  'settings',
  'helper'
], function ($, _, api, uiDialog, uiToast, ViewBase, template, uiGlobal, globalize, settings, helper) {
    var translate = globalize.localizeBase("views.me.profile");

    var View = ViewBase.extend({
        events: {
            "tap [data-action='sign-out']": "signOut"
        },
        initialize: function () {
            this.constructor.__super__.initialize.call(this);

            this.title = translate("title");

            this.render();
        },
        renderTemplate: function () {
            return template.me.profile({
                isAuthenticated: api.isAuthenticated(),
                enableLanguage: settings.enableLanguage,
                enableDeviceInfo:settings.enableDeviceInfo,
                translate:translate
            });
        },
        onpagerenderdone:function(){
            var elements = $("[data-href]", this.$el);
            elements.off(".profile").hammer({
              //  prevent_default: true
            }).on(uiGlobal.event.tap + ".profile", function (e) {
                e.preventDefault();
                helper.handleNavigation($(this));
            });
        },
        signOut: function (e) {

            var self = this;
            uiDialog.confirm(translate("sign-out-confirm")).done(function () {
                api.me.logout();
                uiToast.open(translate("sign-out-message"));
                self.navigate('');
            });

        },
        onBack: function () {
            this.navigateBack();
        }
        
    });
    return View;
});