﻿define([
  'jquery',
  'underscore',
  'views/base',
  'template',
  'globalize'
], function ($, _, ViewBase, template,globalize) {

    var translateShared = globalize.localizeBase("views.shared");
    var translate = globalize.localizeBase("views.privacy-policy");

    var View = ViewBase.extend({
        events: {
            "tap [data-href]": "onLink",
            "tap [data-action]": "onAction",
        },
        initialize: function (options) {
            this.constructor.__super__.initialize.call(this);
            
            this.title = translate("title");

            this.render();
        },
        renderTemplate: function () {
            return template.privacyPolicy({
                translate:translate
            });
        },
        initializeFooter: function (o) {
            o.viewNone();
        },
        initializeHeader: function (o) {
            o.viewSaveCancel({
                title: this.title,
                cancelText: translateShared("close"),
                cancelIcon: "icon-cancel",
                okEnabled: false,
                onCancel: $.proxy(function (e) {
                    this.navigateBack();
                }, this)
            });
        },
        onLink: function (e) {
            if (e) e.preventDefault();

            var link = $(e.target).data("href");
            if (link) {
                window.open(link, "_system");
            }
        },
        onAction: function (e) {
            if (e) e.preventDefault();

        }
       
    });
    return View;
});